/**
   Modification History:
   [1.0]    09.09.2009    Tobias Pluess
   - first release
 *****************************************************************************/

#ifndef __CSTART_H__
#define __CSTART_H__

/******************************************************************************
 * INCLUDE FILES
 *****************************************************************************/

#include "base_def.h"

/******************************************************************************
 * CONSTANT DEFINITIONS
 *****************************************************************************/

#define CLK_IRC 0/* internal RC clock - default */
#define CLK_MAIN 1 /* main oscillator clock source */
#define CLK_RTC 2 /* RTC osc clock source */
#define OSCEN (1 << 5) /* main oscillator enable */
#define OSCSTAT (1 << 6) /* main oscillator status */
#define OSCRANGE_LO 0 /* main oscillator 1..20 MHz */
#define OSCRANGE_HI 1 /* main oscillator 15..24 MHz */
#define OSCRANGE (OSC_RANGE_SEL << 4) /* osc range select */
#define PLLC (1 << 1) /* pll connect bit */
#define PLLE (1 << 0) /* pll enable bit */
#define PLOCK (1 << 26) /* pll lock bit */
#define EMC_RESET_DISABLE (1 << 2) /* emc reset disable feature */

/******************************************************************************
 * OTHER DEFINITIONS (MACROS ETC)
 *****************************************************************************/

/******************************************************************************
 * TYPE DEFINITIONS
 *****************************************************************************/

/******************************************************************************
 * FUNCTION PROTOTYPES (PUBLIC)
 *****************************************************************************/

tDWord fDispatchSWI(tDWord dwSWINbr);

void fLowLevelInit(void);

/******************************************************************************
 * END OF CODE
 *****************************************************************************/

#endif
