#ifndef __ETHERNETIF_H__
#define __ETHERNETIF_H__

#ifdef __cplusplus
extern "C" {
#endif

#define SET_MAC(x) x[0] = MAC_ADDRESS6; x[1] = MAC_ADDRESS5; x[2] = MAC_ADDRESS4; \
  x[3] = MAC_ADDRESS3; x[4] = MAC_ADDRESS2; x[5] = MAC_ADDRESS1;

#define IFNAME0 'e' /* network interface name */
#define IFNAME1 'n'

#define ETH_FRAG_SIZE 1500 /* 1536 */

#define MAC_ADDRESS6 0x00 /* unique mac address */
#define MAC_ADDRESS5 0x16
#define MAC_ADDRESS4 0x35
#define MAC_ADDRESS3 0xAC
#define MAC_ADDRESS2 0x4B
#define MAC_ADDRESS1 0xAE

#define MAX_FRAME 1536 /* maximum frame length */
#define CLRT_DEFAULT 0x0000370F /* default collision window / retry */
#define IPGR_DEFAULT 0x00000C12 /* default back-to-back inter packet gap */

#define PHY_BCR 0 /* basic control register */
#define PHY_STATUS 1 /* status register */
#define PHY_ID1 2 /* phy identifier 1 */
#define PHY_ID2 3 /* phy identifier 2 */
#define PHY_ANA 4 /* auto-negotiation advertisement register */
#define PHY_ANLPA 5 /* auto-negotiation link partner ability register */
#define PHY_ANE 6 /* auto-negotiation expansion register */
#define PHY_ANNP 7 /* auto-negotiation next page register */
#define PHY_LPNPA 8 /* link partner next page ability */
#define PHY_RXER 0x15 /* RXER counter */
#define PHY_ICS 0x1b /* interrupt control/status register */
#define PHY_LCS 0x1d /* LinkMD control/status register */
#define PHY_CTL 0x1e /* PHY control register */
#define PHY_100BTX 0x1f /* 100BASE-TX PHY control register */

#define KSZ8001_ID 0x00221610 /* PHY identifier of micrel KSZ8001L */

#define MAC_RX_FRAGMENTS 5
#define MAC_TX_FRAGMENTS 5

enum netif_status
{
  status_disconnected,
  status_connecting,
  status_connected,
  status_disconnecting
};

err_t
ethernetif_init(struct netif *netif);

void
ethernetif_poll(struct netif *netif);

#ifdef __cplusplus
}
#endif

#endif
